=== firmware/octoclock/lib/CMakeLists.txt ===
#
# Copyright 2014 Ettus Research LLC
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

SET(lib_files
    arp_cache.c
    clkdist.c
    enc28j60.c
    gpsdo.c
    init.c
    network.c
    state.c
    udp_handlers.c
    usart.c
)

IF(OCTOCLOCK_DEBUG)
    LIST(APPEND lib_files serial.c)
ENDIF(OCTOCLOCK_DEBUG)

ADD_LIBRARY(octoclock ${lib_files})
SET_TARGET_PROPERTIES(octoclock
    PROPERTIES COMPILE_FLAGS "${CMAKE_C_FLAGS} -O2 -g"
)
